unit counterView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, counterModel, ObservableComponent;

type
  TTCounterView = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    c : TCounterMOdel;
    observer : TObserver;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; counter : TCounterModel);
    destructor Destroy;  override;
    procedure counterUpdate(arg: TObject);
  end;

  implementation

{$R *.DFM}
constructor TTCounterView.Create(AOwner: TComponent; counter : TCounterModel);
begin
  inherited Create(AOwner);
  c := counter;
  observer := TObserver.create(c,counterUpdate);
end;

destructor TTCounterView.Destroy;
begin
  observer.Destroy;
  inherited destroy;
end;

procedure TTCounterView.Button1Click(Sender: TObject);
begin
 c.reset;
end;

procedure TTCounterView.Button2Click(Sender: TObject);
begin
  c.incr;
end;

procedure TTCounterView.Button3Click(Sender: TObject);
begin
  c.decr;
end;

procedure TTCounterView.counterUpdate;
begin
  edit1.text := c.asString;
end;

procedure TTCounterView.FormShow(Sender: TObject);
begin
  counterUpdate(nil);
end;

end.
